<template>
  <div id="app">
    <!-- navbar -->
    <div class="navbar navbar-expand-lg fixed-top navbar-dark bg-primary">
      <div class="container">
        <router-link to="/" class="navbar-brand">Home</router-link>
        <button
          class="navbar-toggler"
          type="button"
          data-toggle="collapse"
          data-target="#navbarResponsive"
          aria-controls="navbarResponsive"
          aria-expanded="false"
          aria-label="Toggle navigation"
        >
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarResponsive">
          <ul class="navbar-nav">
            <li class="nav-item" v-if="this.$store.getters.isAuthenticated && !this.$store.getters.isAdmin">
              <router-link class="nav-link" to="/groups">Statistics</router-link>
            </li>
            <li class="nav-item" v-if="this.$store.getters.isAuthenticated && !this.$store.getters.isAdmin">
              <router-link class="nav-link" to="/orders">Orders</router-link>
            </li>
            <li class="nav-item" v-if="this.$store.getters.isAuthenticated && this.$store.getters.isAdmin">
              <router-link class="nav-link" to="/admin">Admin Page</router-link>
            </li>
          </ul>
        </div>
        <div class="collapse navbar-collapse" id="navbarResponsive2">
          <ul class="navbar-nav ml-auto">
            <li class="nav-item" v-if="this.$store.getters.isAuthenticated">
              <a class="nav-link waves-effect waves-light" v-on:click="logout">
                <i class="fas fa-sign-out"></i> Logout
              </a>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <div class="container">
      <transition name="moveInUp">
        <router-view />
      </transition>
    </div>
  </div>
</template>

<script>
import { AXIOS } from "./components/http-common";

export default {
  name: "app",
  methods: {
    logout() {
      var path = '/auth/logout'
      if (this.$store.getters.isAdmin) {
        path = '/admin/logout'
      }
      AXIOS.post(path, {})
        .then(
          response => {
            console.log(response);
            this.$store.dispatch("logout");
            this.$cookies.remove("token");
            this.$router.push("/");
          },
          error => {
            console.log(error);
            this.$store.dispatch("logout");
            this.$cookies.remove("token");
            this.$router.push("/");
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.hasError = true;
        });
    }
  }
};
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
.moveInUp-enter-active {
  animation: fadeIn 2s ease-in;
}
@keyframes fadeIn {
  0% {
    opacity: 0;
  }
  50% {
    opacity: 0.5;
  }
  100% {
    opacity: 1;
  }
}
.moveInUp-leave-active {
  animation: moveInUp 0.3s ease-in;
}
@keyframes moveInUp {
  0% {
    transform: translateY(0);
  }
  100% {
    transform: translateY(-400px);
  }
}
</style>
